## Measurements

This report was generated with the measure-analysis.py script.
JSON formated measures were imported in the measures folder using the import functionnality of the script, this report was then generated using these measures.
Metadata is included with the measures, such as the kernel version used, the boot parameters passed, various others parameters specific to the measure, etc... 
Measures measuring the same propriety are grouped together in tables and graphs, and are identified by their diverging metadatas. This is useful to analyse the effect of specific parameters on the  measured propriety.

### Description of the metadata associated to each test

* **dev**: Device on which the tests were run
* **ker**: Linux kernel version used
* **prio**: Priority of the real-time thread
* **i**: Interval between each packet transmission
* **boot_p**: Boot Parameters passed to u-boot
* **delta**: ETF qdisc delta value
* **load**: External device and processor load during the test
* **duration**: Duration of the test
* **speed**: Ethernet speed in Mb/s
* **etf_offset**: When a packet\s txtime is scheduled, the txtime set is the current time offset by etf_offset
* **route**: How the boards are connected. switch means they are connected by a switch (cheap, unmanaged), E2E
* **qdisc**: qdisc used to send packets
* **client**: Device which sent the packets
* **server**: Device which received the packets
* **XDP**: Were XDP sockets used
* **delay**: Callback schedule delay in us

### cyclictest_wake-up_latency results

Uses cyclictest from the rt-tests test suite to measure wake-up latency. A real-time thread is run on CPU1, and wakes up at a regular interval (specified by the interval parameter) using clock_nanosleep. It then uses clock_gettime and computes the difference between the scheduled wake-up time and the effective wake-up time measured by clock_gettime.
The command used is: cyclictest -p `prio` -a1 -t1 -n -h 200 -q -i `interval`

**Common test metadata:** Task priority: 98, Interval: 200us, Boot Parameters: isolcpus,rcu_nocbs,irqaffinity, ETF qdisc delta: None, Device and processor load: None, qdisc: pfifo_fast, XDP: no

Metadata               | Minimum             | Maximum             | Average             | Standard deviation  | Lost packets
---------------------- | ------------------- | ------------------- | ------------------- | ------------------- | ------------
**dev, ker, duration** | **Wake-up latency** | **Wake-up latency** | **Wake-up latency** | **Wake-up latency** |             
Shuttle, 4.19, 16h35   | 1.0us               | 14.0us              | 1.0us               | 0.1us               | 0           
A20, 5.6, 18h13        | 8.0us               | 73.0us              | 9.3us               | 1.5us               | 0           

![alt text](measures/graphs/cyclictest_wake-up_latencyWake-up latency.png "cyclictest_wake-up_latency Graph")

### ping_interval results

ping measures with command `taskset 2 chrt -f 98 ping -i 0.001 -q IP`


**Common test metadata:** Linux kernel version: 5.6, Task priority: 98, Interval: 1000us, Boot Parameters: isolcpus,rcu_nocbs,irqaffinity, ETF qdisc delta: None, Device and processor load: None, Speed (Mb/s): 1000, Packet route: E2E, XDP: no

Metadata                     | Minimum      | Maximum      | Average      | Standard deviation | Lost packets
---------------------------- | ------------ | ------------ | ------------ | ------------------ | ------------
**duration, client, server** | **ping RTT** | **ping RTT** | **ping RTT** | **ping RTT**       |             
0h37, Shuttle, A20           | 59.0us       | 460.0us      | 272.0us      | 74.0us             | 0           
0h13, A20, Shuttle           | 77.0us       | 569.0us      | 293.0us      | 45.0us             | 0           

![alt text](measures/graphs/ping_intervalping RTT.png "ping_interval Graph")

### shuttle_a20_signal_jitter results

Two A20 boards are connected end to end with an ethernet cable to a shuttle. All devices are synchronized with PTP. The shuttle sends packets containing timestamps to the boards, and the boards emit a signal at the given timestamp. A logic analyzer measures the variation difference between the signals of the two boards.

**Common test metadata:** Device: A20, Linux kernel version: 5.6, Task priority: 98, Boot Parameters: isolcpus,rcu_nocbs,irqaffinity, ETF qdisc delta: None, Device and processor load: None, Speed (Mb/s): 1000, ETF offset: 500us, Packet route: E2E, qdisc: pfifo_fast

Metadata                    | Minimum                   | Maximum                   | Average                   | Standard deviation        | Lost packets
--------------------------- | ------------------------- | ------------------------- | ------------------------- | ------------------------- | ------------
**i, duration, delay, XDP** | **edge to edge - period** | **edge to edge - period** | **edge to edge - period** | **edge to edge - period** |             
1000us, 9h59, 600us, no     | 0.0us - 958.0us           | 129.0us - 1063.0us        | 7.5us - 999.5us           | 9.6us - 1.8us             | 0           
500us, 13h59, 400us, no     | 0.0us - 360.0us           | 265.0us - 582.0us         | 10.6us - 499.5us          | 9.8us - 1.4us             | 0           
500us, 14h59, 350us, yes    | 0.0us - 443.0us           | 101.0us - 558.0us         | 9.4us - 499.5us           | 8.2us - 1.1us             | 0           
300us, 1h13, 250us, yes     | 0.0us - 251.0us           | 84.0us - 352.0us          | 8.4us - 299.5us           | 6.9us - 2.0us             | 0           

![alt text](measures/graphs/shuttle_a20_signal_jitteredge to edge.png "shuttle_a20_signal_jitter Graph")

![alt text](measures/graphs/shuttle_a20_signal_jitterperiod.png "shuttle_a20_signal_jitter Graph")

### packet_jitter results

A UDP packet is periodically sent from one device to another using a real time thread. The receiving device calculates the intervals between the packets it receives, and sees how much it differs from the scheduled interval.

**Common test metadata:** Linux kernel version: 5.6, Task priority: 98, Interval: 500us, Boot Parameters: isolcpus,rcu_nocbs,irqaffinity, ETF qdisc delta: None, Device and processor load: None, Speed (Mb/s): 1000, ETF offset: 500us, Packet route: E2E, qdisc: pfifo_fast, Client device: Shuttle, Server device: A20, Callback delay: none

Metadata          | Minimum           | Maximum           | Average           | Standard deviation | Lost packets
----------------- | ----------------- | ----------------- | ----------------- | ------------------ | ------------
**duration, XDP** | **Packet jitter** | **Packet jitter** | **Packet jitter** | **Packet jitter**  |             
0h21, no          | 0.0us             | 257.0us           | 114.5us           | 4.0us              | 0           
0h22, no          | 0.0us             | 272.0us           | 115.5us           | 7.3us              | 0           
0h30, yes         | 0.0us             | 176.0us           | 79.5us            | 2.3us              | 0           
0h30, yes         | 0.0us             | 234.0us           | 106.5us           | 8.3us              | 0           

![alt text](measures/graphs/packet_jitterPacket jitter.png "packet_jitter Graph")

### packet_latency results

Same setup as packet jitter measures. Client and server are synchronized with PTP, the client checks the time before sending the packet, and sends it in the packet. The servechecks the time after receiving the packet, and records the difference between both timestamps to calculate latency.

**Common test metadata:** Linux kernel version: 5.6, Task priority: 98, Boot Parameters: isolcpus,rcu_nocbs,irqaffinity, ETF qdisc delta: None, Device and processor load: None, Speed (Mb/s): 1000, ETF offset: 500us, Packet route: E2E, qdisc: pfifo_fast, Callback delay: none

Metadata                             | Minimum            | Maximum            | Average            | Standard deviation | Lost packets
------------------------------------ | ------------------ | ------------------ | ------------------ | ------------------ | ------------
**duration, XDP, i, client, server** | **Packet latency** | **Packet latency** | **Packet latency** | **Packet latency** |             
29h26, yes, 500us, Shuttle, A20      | 17.0us             | 233.0us            | 49.5us             | 8.0us              | 0           
0h59, no, 500us, Shuttle, A20        | 67.0us             | 493.0us            | 122.7us            | 20.7us             | 0           
0h59, no, 500us, Shuttle, A20        | 69.0us             | 519.0us            | 124.7us            | 21.7us             | 0           
15h39, no, 1000us, A20, Shuttle      | 97.0us             | 425.0us            | 109.9us            | 10.1us             | 0           

![alt text](measures/graphs/packet_latencyPacket latency.png "packet_latency Graph")


## Additional measures

## Packet transmission latency

### Shuttle to A20

#### Measures done with tracing and timestamps (some overhead):

**Without XDP:**

| **Latency measured**                   | **min** | **avg** | **max** |
| -------------------------------------- | ------- | ------- | ------- |
| IRQ -> RX SO_TIMESTAMP                 |   27us  |   31us  |  136us  |
| RX SO_TIMESTAMP -> Userspace timestamp |   85us  |   93us  |  247us  |
| IRQ -> Userspace timestamp             |  112us  |  124us  |  383us  |

**With XDP:**

IRQ -> XDP_REDIRECT : ~30us (more measures needs to be done)

#### Measures done with timestamps (little overhead):

| **Latency measured**                   |        | **Duration** | **Packets number** | **Interval** | **min** | **avg** |  **max** |  
| -------------------------------------- | ------ | ------------ | ------------------ | ------------ | ------- | ------  | ------   |  
| Shuttle timestamp -> A20 timestamp     | XDP    |  2h45        | 50 100 000         | 250us        |   22us  |   24us  |  173us   |
| Shuttle timestamp -> A20 timestamp     | no XDP |              |                    |              |   88us  |   88us  |  300us   |
| RX SO_TIMESTAMP (A20)                  | no XDP |              |                    |              |   67us  |  172us  |  173us   |
| TX SO_TIMESTAMP -> (Shuttle)           | no XDP |              |                    |              |    2us  |   18us  |   20us   |

#### PTP path delay and master offset


| **Measure**          | **min** | **avg** | **max** |
| ---------------------| ------- | ------- | ------- |
| Master offset        |  -42us  |   0us   |  71us   |
| Path delay           |  23us   |  31us   |  47us   |
